# Class: TileWMS

## ol.source.TileWMS

Layer source for tile data from WMS servers.

#### new ol.source.TileWMS(opt_options) experimental

src/ol/source/tilewmssource.js, line 32

  Name | Type | Description
  --- | --- | ---
  `options` | optional Tile WMS options.
  Name | Type | Description
  --- | --- | ---
  `attributions` | Array.<ol.Attribution> | undefined | optional Attributions.
  `params` | Object.<string, *> | WMS request parameters. At least a `LAYERS` param is required. `STYLES` is `''` by default. `VERSION` is `1.3.0` by default. `WIDTH`, `HEIGHT`, `BBOX` and `CRS` (`SRS` for WMS version < 1.3.0) will be set dynamically.
  `crossOrigin` | null | string | undefined | optional crossOrigin setting for image requests.
  `extent` | ol.Extent | undefined | optional Extent.
  `gutter` | number | undefined | optional The size in pixels of the gutter around image tiles to ignore. By setting this property to a non-zero value, images will be requested that are wider and taller than the tile size by a value of `2 x gutter`. Defaults to zero. Using a non-zero value allows artifacts of rendering at tile edges to be ignored. If you control the WMS service it is recommended to address "artifacts at tile edges" issues by properly configuring the WMS service. For example, MapServer has a `tile_map_edge_buffer` configuration parameter for this. See http://mapserver.org/output/tile_mode.html.
  `hidpi` | boolean | undefined | optional Use the `ol.Map#pixelRatio` value when requesting the image from the remote server. Default is `true`.
  `logo` | string | undefined | optional Logo.
  `tileGrid` | ol.tilegrid.TileGrid | undefined | optional Tile grid.
  `maxZoom` | number | undefined | optional Maximum zoom.
  `projection` | ol.proj.ProjectionLike | Projection.
  `serverType` | ol.source.wms.ServerType | string | undefined | optional The type of the remote WMS server. Currently only used when `hidpi` is `true`. Default is `undefined`.
  `tileLoadFunction` | ol.TileLoadFunctionType | undefined | optional Optional function to load a tile given a URL.
  `url` | string | undefined | optional WMS service URL.
  `urls` | Array.<string> | undefined | optional WMS service urls. Use this instead of `url` when the WMS supports multiple urls for GetMap requests.

  ##### Fires:

  - `change` experimental - Triggered when the state of the source changes.

### Extends

- ol.source.TileImage

### Methods

#### dispatchChangeEvent() inherited experimental

src/ol/observable.js, line 41

  Dispatches a `change` event.

  ##### Fires:

  - `change` experimental

#### getGetFeatureInfoUrl(coordinate, resolution, projection, params){string|undefined} experimental

src/ol/source/tilewmssource.js, line 127

  Return the GetFeatureInfo URL for the passed coordinate, resolution, and projection. Return `undefined` if the GetFeatureInfo URL cannot be constructed.

  Name | Type | Description
  --- | --- | ---
  `coordinate` | ol.Coordinate | Coordinate.
  `resolution` | number | Resolution.
  `projection` | ol.proj.Projection | Projection.
  `params` | Object | GetFeatureInfo params. `INFO_FORMAT` at least should be provided. If `QUERY_LAYERS` is not provided then the layers specified in the `LAYERS` parameter will be used. `VERSION` should not be specified here.

  ##### Returns:

  GetFeatureInfo URL.

#### getParams(){Object} experimental

src/ol/source/tilewmssource.js, line 205

  Get the user-provided params, i.e. those passed to the constructor through the "params" option, and possibly updated using the updateParams method.

  ##### Returns:

  Params.

#### getState(){ol.source.State} inherited experimental

src/ol/source/source.js, line 142

  ##### Returns:

  State.

#### getTileGrid(){ol.tilegrid.TileGrid} inherited experimental

src/ol/source/tilesource.js, line 167

  ##### Returns:

  Tile grid.

#### getTileLoadFunction(){ol.TileLoadFunctionType} inherited experimental

src/ol/source/tileimagesource.js, line 130

  ##### Returns:

  TileLoadFunction

#### getTileUrlFunction(){ol.TileUrlFunctionType} inherited experimental

src/ol/source/tileimagesource.js, line 139

  ##### Returns:

  TileUrlFunction

#### getUrls(){Array.<string>|undefined} experimental

src/ol/source/tilewmssource.js, line 305

  Return the URLs used for this WMS source.

  ##### Returns:

  URLs.

#### on(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 63

  Listen for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### once(type, listener, opt_this){goog.events.Key} inherited experimental

src/ol/observable.js, line 76

  Listen once for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

  ##### Returns:

  Unique key for the listener.

#### setTileLoadFunction(tileLoadFunction) inherited experimental

src/ol/source/tileimagesource.js, line 148

  Name | Type | Description
  --- | --- | ---
  `tileLoadFunction` | ol.TileLoadFunctionType | Tile load function.

#### setTileUrlFunction(tileUrlFunction) inherited experimental

src/ol/source/tileimagesource.js, line 159

  Name | Type | Description
  --- | --- | ---
  `tileUrlFunction` | ol.TileUrlFunctionType | Tile URL function.

#### un(type, listener, opt_this) inherited experimental

src/ol/observable.js, line 88

  Unlisten for a certain type of event.

  Name | Type | Description
  --- | --- | ---
  `type` | string | Array.<string> | The event type or array of event types.
  `listener` | function | The listener function.
  `this` | Object | optional The object to use as `this` in `listener`.

#### unByKey(key) inherited experimental

src/ol/observable.js, line 98

  Removes an event listener using the key returned by `on()` or `once()`.

  Name | Type | Description
  --- | --- | ---
  `key` | goog.events.Key | Key.

#### updateParams(params) experimental

src/ol/source/tilewmssource.js, line 389

  Update the user-provided params.

  Name | Type | Description
  --- | --- | ---
  `params` | Object | Params.